import * as WebSocket from "ws";
export default class Database {
    private initLock;
    socket: WebSocket;
    constructor(url: string, database: string, accesskey?: string, authkey?: string, rootkey?: string);
    requests: Map<string, (err: Error, data: any) => void>;
    eventhandler: Map<string, (data: any) => void>;
    private handleResponse;
    private handleEvent;
    private queryRequest;
    get(path: string | string[]): Promise<any>;
    set(path: string | string[], data: any): Promise<any>;
    push(path: string | string[], data: any): Promise<any>;
    subscribe(path: string | string[], type: "push" | "set", ondata: (data: any) => void): Promise<{
        unsubscribe: () => void;
    }>;
}
