"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const node_1 = require("./node");
const log = (pref, prms) => prms.then(val => console.log(pref + ": ", val));
(async () => {
    const db = new node_1.default("http://localhost:5000", "test_database", "access87125t487123897458725123", undefined, "root12341213312312365465as4df6");
    console.log("Start!");
    let coll1 = db.collection("test1");
    await coll1.delete(); //Clean the Database
    await log("COLL1 keys", coll1.keys().then(() => "Make sure to clear database before testing!").catch(() => "Successfully thrown an error on not existing collection"));
    let doc1;
    await log("Adding new document with push", coll1.push({ name: "Max Mustermann" }).then(res => doc1 = res).then(res => res.key));
    let doc2 = coll1.doc();
    await log("Adding new document with doc().set(...)", doc2.set({ name: "Franz Mustermann" }));
    await log("COLL1 keys", coll1.keys());
    await log("Getting first added document", doc1.get());
    await log("Override first added document", doc1.set({ name: "Lisa Mustermann" }));
    await log("Getting first added document", doc1.get());
    await log("Deleting new document", doc1.delete());
    await log("Getting first added document", doc1.get());
    await coll1.subscribe(["added", "modified", "deleted"], { existing: true }, (change) => {
        console.log("Change: ", change.type, change.doc.data);
    });
    await doc2.set({ name: "Micha Ekkehardt" });
    await new Promise((resolve) => setTimeout(resolve, 5000));
    db.close();
})()
    .catch(err => console.error(err))
    .then(() => process.exit());
//# sourceMappingURL=test.js.map